
Ruby - Bug #15577

FileUtils.remove_entry_secure() raises unexpected NameError

01/31/2019 12:06 PM - Tietew (Toru Iwase)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.6.1p33 (2019-01-30 revision

66950) [x86_64-linux]

Backport: 2.4: DONTNEED, 2.5: DONTNEED, 2.6:

DONE

Description

How to reproduce

$ sudo mkdir /tmp/foobar

$ ruby -rfileutils -e 'FileUtils.remove_entry_secure("/tmp/foobar")'

Traceback (most recent call last):

        4: from -e:1:in `<main>'

        3: from /usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:689:in `re

move_entry_secure'

        2: from /usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:689:in `op

en'

        1: from /usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:695:in `bl

ock in remove_entry_secure'

/usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:695:in `chown': Operation 

not permitted @ rb_file_chown - /tmp/foobar/. (Errno::EPERM)

        2: from -e:1:in `<main>'

        1: from /usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:688:in `re

move_entry_secure'

/usr/local/anyenv/envs/rbenv/versions/2.6.1/lib/ruby/2.6.0/fileutils.rb:698:in `rescue in remove_e

ntry_secure': uninitialized constant FileUtils::EISDIR (NameError)

 

Expected

Raises Errno::EPERM

Actual

Raises NameError (uninitialized constant FileUtils::EISDIR)

Patch

diff --git a/lib/fileutils.rb b/lib/fileutils.rb

index dc7261857b..8981ef98e8 100644

--- a/lib/fileutils.rb

+++ b/lib/fileutils.rb

@@ -695,7 +695,7 @@ def remove_entry_secure(path, force = false)

         f.chown euid, -1

         f.chmod 0700

       }

-    rescue EISDIR # JRuby in non-native mode can't open files as dirs

+    rescue Errno::EISDIR # JRuby in non-native mode can't open files as dirs

       File.lstat(dot_file).tap {|fstat|

         unless fu_stat_identical_entry?(st, fstat)

           # symlink (TOC-to-TOU attack?)

 

Versions

2.3.8: Good

2.4.5: Good

2.5.3: Good
2.6.1: Bad

trunk: Bad

Associated revisions

Revision cb5a32981404e1bd691978ad9e7ce6a824315995 - 01/31/2019 02:02 PM - nobu (Nobuyoshi Nakada)

Fix exception namespace

lib/fileutils.rb (remove_entry_secure): EISDIR is under the

Errno namespace.  [ruby-core:91362] [Bug #15577]

From: Tietew (Toru Iwase) tietew@tietew.net

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@66972 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision cb5a32981404e1bd691978ad9e7ce6a824315995 - 01/31/2019 02:02 PM - nobu (Nobuyoshi Nakada)

Fix exception namespace

lib/fileutils.rb (remove_entry_secure): EISDIR is under the

Errno namespace.  [ruby-core:91362] [Bug #15577]

From: Tietew (Toru Iwase) tietew@tietew.net

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@66972 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision cb5a3298 - 01/31/2019 02:02 PM - nobu (Nobuyoshi Nakada)

Fix exception namespace

lib/fileutils.rb (remove_entry_secure): EISDIR is under the

Errno namespace.  [ruby-core:91362] [Bug #15577]

From: Tietew (Toru Iwase) tietew@tietew.net

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@66972 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 470a7046d45b4a16c457698137326c8ce212d459 - 03/06/2019 07:14 AM - naruse (Yui NARUSE)

merge revision(s) 66972: [Backport #15577]

    Fix exception namespace

    * lib/fileutils.rb (remove_entry_secure): EISDIR is under the

      Errno namespace.  [ruby-core:91362] [Bug #15577]

    From: Tietew (Toru Iwase) <tietew@tietew.net>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67177 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 470a7046d45b4a16c457698137326c8ce212d459 - 03/06/2019 07:14 AM - naruse (Yui NARUSE)

merge revision(s) 66972: [Backport #15577]

    Fix exception namespace

    * lib/fileutils.rb (remove_entry_secure): EISDIR is under the

      Errno namespace.  [ruby-core:91362] [Bug #15577]

    From: Tietew (Toru Iwase) <tietew@tietew.net>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67177 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 470a7046 - 03/06/2019 07:14 AM - naruse (Yui NARUSE)

merge revision(s) 66972: [Backport #15577]

    Fix exception namespace

    * lib/fileutils.rb (remove_entry_secure): EISDIR is under the

      Errno namespace.  [ruby-core:91362] [Bug #15577]

    From: Tietew (Toru Iwase) <tietew@tietew.net>

05/17/2025 2/3

mailto:tietew@tietew.net
mailto:tietew@tietew.net
mailto:tietew@tietew.net


 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67177 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 50a334d864cb0dcbe8cf8e1f0403a439e9b3debe - 03/11/2019 07:18 AM - naruse (Yui NARUSE)

merge revision(s) 66973: [Backport #15577]

    Run r66972 assertion only when a sticky-bit makes sense

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67210 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 50a334d864cb0dcbe8cf8e1f0403a439e9b3debe - 03/11/2019 07:18 AM - naruse (Yui NARUSE)

merge revision(s) 66973: [Backport #15577]

    Run r66972 assertion only when a sticky-bit makes sense

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67210 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 50a334d8 - 03/11/2019 07:18 AM - naruse (Yui NARUSE)

merge revision(s) 66973: [Backport #15577]

    Run r66972 assertion only when a sticky-bit makes sense

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_6@67210 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/31/2019 01:11 PM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.4: UNKNOWN, 2.5: UNKNOWN, 2.6: UNKNOWN to 2.4: DONTNEED, 2.5: DONTNEED, 2.6: REQUIRED

#2 - 01/31/2019 02:02 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r66972.

Fix exception namespace

lib/fileutils.rb (remove_entry_secure): EISDIR is under the

Errno namespace.  [ruby-core:91362] [Bug #15577]

From: Tietew (Toru Iwase) tietew@tietew.net

#3 - 03/06/2019 07:37 AM - naruse (Yui NARUSE)

- Backport changed from 2.4: DONTNEED, 2.5: DONTNEED, 2.6: REQUIRED to 2.4: DONTNEED, 2.5: DONTNEED, 2.6: DONE

ruby_2_6 r67177 merged revision(s) 66972.
